#include "os.h"

int main()
{
    k_clear_screen();

    // GDT, IDT, ISRS, IRQ, timer, keyboard, paging, enable interrupts
    gdt_install();
    idt_install();
    isrs_install();
    irq_install();
    timer_install();
    keyboard_install();
    paging_install();
    initODA();
    sti();

    printformat("   ************************************************\n");
	printformat("   *          Welcome to PrettyOS 0.06            *\n");
	printformat("   *          Paging is activated                 *\n");
	printformat("   ************************************************\n");
    printformat("KQ: %x TAIL: %x HEAD: %x", pODA->KEYQUEUE, pODA->pTailKQ, pODA->pHeadKQ);

    settextcolor(2,0);
	set_cursor(0,6);

    UINT c=0;
	while(TRUE)
	{
	  if( k_checkKQ_and_print_char() )
	  {
	    ++c;
	    if(c>79)
	    {
	      c=0;
	      settextcolor(4,0);
	      printformat("\nT: %x H: %x WRITE: %i Read: %i ", pODA->pTailKQ, pODA->pHeadKQ, pODA->KQ_count_write, pODA->KQ_count_read);
          printformat("*T: %c %i *H: %c %i\n", *(pODA->pTailKQ),*(pODA->pTailKQ),*(pODA->pHeadKQ),*(pODA->pHeadKQ));
          settextcolor(2,0);
	    }
	  }
	}

	return 0;
}
